﻿using Infragistics.Controls.Editors;
using Infragistics.Controls.Editors.Primitives;
using Infragistics.Documents.RichText;
using Infragistics.Windows;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Controls.Primitives;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace XamRichTextEditor_scroll_buttons
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
       
       ManualResetEvent oSignalEvent = new ManualResetEvent(false);
        public MainWindow()
        {
           InitializeComponent();
            this.ConfirmButton.IsEnabled = false;
            RichTextDocument doc = this.xrte1.Document;
            ParagraphNode pn = new ParagraphNode();
            pn.SetText(@"Lorem ipsum dolor sit amet, consectetur adipiscing elit.Sed tincidunt risus sit amet sapien suscipit, 
                         ut volutpat nibh tristique.In fermentum consequat risus, non cursus felis fermentum at.
                         Etiam quis facilisis urna, vel dapibus mi.Suspendisse potenti.Vivamus finibus aliquet neque et rutrum.
                         Praesent tincidunt rutrum consectetur.Morbi sodales mi vitae metus finibus, vel fringilla elit iaculis.
                         Pellentesque dui mauris, suscipit quis purus sed, posuere fringilla ex.Duis scelerisque, 
                         augue venenatis congue tempus, lacus turpis lobortis felis, nec volutpat nisi ante ac libero.
                         Aliquam vestibulum nisl sit amet nisl tincidunt placerat.
                         Nulla facilisi.Integer egestas non ex nec porttitor.Class aptent taciti sociosqu ad litora torquent per conubia nostra, 
                         per inceptos himenaeos.In imperdiet viverra lacus, nec feugiat arcu tincidunt vel.Vestibulum convallis, 
                         nulla eget vehicula semper, nunc ante viverra felis, at dignissim augue mi in tortor.Nullam ac posuere risus, 
                         vel faucibus justo.In aliquet elit massa, blandit iaculis tortor faucibus sit amet.
                         Ut eu nulla a nisl rhoncus malesuada.Praesent hendrerit vulputate ex, id lobortis dui.Sed id mauris auctor, 
                         fermentum velit non, imperdiet mi.Nunc pulvinar, orci at porttitor aliquet, massa ligula dictum turpis, 
                         eu convallis nisl odio ac orci.Nullam ac leo sed mi gravida egestas.Nam tortor risus, posuere quis scelerisque sit amet,
                         tincidunt nec mauris.Nunc sagittis tortor ut libero mattis tempor.Proin pretium sagittis neque, 
                         ac ornare nibh lacinia id.Curabitur ultrices pretium eleifend.Aenean condimentum tellus eu dolor egestas, 
                         ut viverra ligula rhoncus.Integer nisl turpis, ultrices non pellentesque sit amet, tempus vitae nunc.
                         Sed sed massa sapien.Aliquam facilisis odio eu mauris gravida, non commodo augue iaculis.
                         Morbi in massa felis.In a lorem porta, imperdiet elit quis, gravida augue.Nulla commodo diam ac ipsum viverra, 
                         in pulvinar elit eleifend.Pellentesque eget finibus sapien.Donec nunc massa, pharetra id tempus eget, 
                         pharetra at dolor.Vestibulum ante ipsum primis in faucibus orci luctus et ultrices posuere cubilia curae; 
                         Class aptent taciti sociosqu ad litora torquent per conubia nostra, per inceptos himenaeos. 
                         Donec eu orci orci. Nullam est nisl, dignissim ut velit in, malesuada venenatis enim.
                         Nullam tincidunt risus et vehicula consectetur. Fusce feugiat porttitor varius. Proin a molestie tortor. ");
            doc.RootNode.Body.ChildNodes.Add(pn);

        }
        Thread scroll;
        void scrolling (ScrollBar scrollBar, string direction)
        {
            if(direction == "up")
            {
                while (true)
                {
                    this.Dispatcher.Invoke((Action)(() =>
                {
                    scrollBar.Value -= scrollBar.SmallChange;
                }));
                    Thread.Sleep(300);
                }
            }
            else
            {
                while (true)
                {
                    this.Dispatcher.Invoke((Action)(() =>
                {
                    scrollBar.Value += scrollBar.SmallChange;
                }));
                    Thread.Sleep(300);
                }
            }
        }

        //DOWN
      
        private void Button_PreviewMouseDown(object sender, MouseButtonEventArgs e)
        {     
           
            var scrollBar = Utilities.GetDescendantFromType((this.xrte1), typeof(ScrollBar), true) as ScrollBar;
            scroll = new Thread(delegate () { scrolling(scrollBar, "down"); });
           
            scroll.Start();
            //scrolling(scrollBar, "down");

        }

        private void Button_PreviewMouseUp(object sender, MouseButtonEventArgs e)
        {
            scroll.Abort();
        }


        //UP
        private void Button_PreviewMouseDown_1(object sender, MouseButtonEventArgs e)
        {
            var scrollBar = Utilities.GetDescendantFromType((this.xrte1), typeof(ScrollBar), true) as ScrollBar;
            scroll = new Thread(delegate () { scrolling(scrollBar, "up"); });

            scroll.Start();
            //scrolling(scrollBar, "up");
        }

        private void Button_PreviewMouseUp_1(object sender, MouseButtonEventArgs e)
        {
            scroll.Abort();
        }

        private void Xrte1_Loaded(object sender, RoutedEventArgs e)
        {
            var scrollBar = Utilities.GetDescendantFromType((this.xrte1), typeof(ScrollBar), true) as ScrollBar;
            scrollBar.ValueChanged += ScrollBar_ValueChanged;
        }

        private void ScrollBar_ValueChanged(object sender, RoutedPropertyChangedEventArgs<double> e)
        {
            if(e.NewValue == (sender as ScrollBar).Maximum)
            {
                this.ConfirmButton.IsEnabled = true;
            }
        }
    }
}
